//+------------------------------------------------------------------+
//|Stochastic_Env.mq4.mq4
//| leonid553 & co) (  NoName)
//| 
//| http://www.tradersforum.net.ru/
//+------------------------------------------------------------------+
#property copyright "leonid553 & co"
#property link      "http://www.tradersforum.net.ru/"
//----------------------------------------------------

//---- input parameters---------
extern int     Stochastic_period=14;
extern int     Env_period=25;
extern int     Env_shift=1;
extern double  Env_deviation=20;
extern int    RangePeriods=42;
extern double PriceSmoothing=0.8; 
extern double IndexSmoothing=0.4;
extern int    x1 = 210;
extern int    x2 = 108;
extern int    x3 = 34;
extern int    x4 = 31; 
//------------------------------
extern int     TP=30;
extern int     SL=30;
//extern double  Lot=0.1;
extern int     Slippage=3;
//-------------------
int   up_lim  =75;     // 
int   low_lim =25;     // 
//-------------------
int    ticket;
int    MAGIC;

color    clModifyBuy  = Green;
color    clModifySell = Blue;
//--   --
#include  <b-Lots.mqh> 
#include  <a-SimpleTrailing.mqh> 
//---------------------------

//*********************************************************************

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
if (Env_deviation==0) Env_deviation=0.1;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//*********************************************************************
 Comment(perceptron());
double Stochastic_array[49];
//------   Stochastic-----------------
int    i=0;
while (i<50)
 {
Stochastic_array[i]= iStochastic(NULL, 0, Stochastic_period, 3,3,MODE_SMA,0,MODE_MAIN, i);
i++;
 }
//------------------------------------------------------


ArraySetAsSeries(Stochastic_array,true);

double
En0_low=iEnvelopesOnArray(Stochastic_array,0,Env_period,0,Env_shift,Env_deviation,MODE_LOWER,0);

double
En0_up=iEnvelopesOnArray(Stochastic_array,0,Env_period,0,Env_shift,Env_deviation,MODE_UPPER,0);

double Stochastic_0=iStochastic(NULL, 0, Stochastic_period, 3,3,MODE_SMA,0,MODE_MAIN, 0);
double Stochastic_1=iStochastic(NULL, 0, Stochastic_period, 3,3,MODE_SMA,0,MODE_MAIN, 1);
 
//=====      =========================================================

int Orders=OrdersTotal ();     // -  
if (Orders==0)                 //   
  {  
//---------   ----------------------------

  if   (  /*(Stochastic_1<low_lim)  &&
          (Stochastic_0>low_lim)  &&*/
          (Stochastic_1<En0_low)  &&
          (Stochastic_0>En0_low) &&
          ( perceptron()>0)  )
   {
  Lots=GetSizeLot(); 
  ticket=OrderSend(Symbol(),0,Lots,Ask,Slippage,Bid-SL*Point,Ask+TP*Point,NULL,0,0,CLR_NONE);
  if    (ticket<0) { Print("   BUY #", GetLastError()); return (0); }  
  else
     {
     if (OrderSelect(ticket, SELECT_BY_TICKET) == true)
     
        { MAGIC=OrderMagicNumber(); }
         
     else  { Print("    BUY #", GetLastError() ); }
     }            
   }
//------------------------------------------------------------------

//--------   ------------------------------
  if  ( /*(Stochastic_1>up_lim)  &&
          (Stochastic_0<up_lim)  &&  */
          (Stochastic_1>En0_up)  &&
          (Stochastic_0<En0_up) && 
          ( perceptron()<0)) 
   { 
  Lots=GetSizeLot();      
  ticket=OrderSend(Symbol(),1,Lots,Bid,Slippage,Bid+SL*Point,Bid-TP*Point,NULL,0,0,CLR_NONE);
  if (ticket<0) { Print("   SELL #", GetLastError()); return (0); } 
  else
     {
     if (OrderSelect(ticket, SELECT_BY_TICKET) == true)
     
       { MAGIC=OrderMagicNumber(); }
       
     else  {Print("    SELL #", GetLastError() ); } 
     }                 
   }
  
//------------------------------------------------------------------
  }
//===============================================================================================
if (UseTrailing == true)  TrailingPositions(); 

//----
   return(0);
  }
//+------------------------------------------------------------------+
double perceptron() 
  {
   double w1 = x1 - 100.0;
   double w2 = x2 - 100.0;
   double w3 = x3 - 100.0;
   double w4 = x4 - 100.0;
   double a1 = iCustom(NULL, 0, "Fisher_m11",RangePeriods,PriceSmoothing, IndexSmoothing,0,0); 

   double a2 = iCustom(NULL, 0, "Fisher_m11",RangePeriods,PriceSmoothing, IndexSmoothing,0,7); 

   double a3 = iCustom(NULL, 0, "Fisher_m11",RangePeriods,PriceSmoothing, IndexSmoothing,0,14); 

   double a4 = iCustom(NULL, 0, "Fisher_m11",RangePeriods,PriceSmoothing, IndexSmoothing,0,21); 

   return (w1 * a1 + w2 * a2 + w3 * a3 + w4 * a4);
  }

